import Cookies from 'js-cookie'

const state = {
  sidebar: {
    // opened: Cookies.get('sidebarStatus') ? !! + Cookies.get('sidebarStatus') : true,
    opened: Cookies.get('sidebarStatus') =='0' ? false : true,
    withoutAnimation: false,
    hide: false
  },
  device: 'desktop',
  size: Cookies.get('size') || 'medium'
}

const mutations = {
  TOGGLE_SIDEBAR: (state:any) => {
    if (state.sidebar.hide) {
      return false;
    }
    state.sidebar.opened = !state.sidebar.opened
    state.sidebar.withoutAnimation = false
    if (state.sidebar.opened) {
      Cookies.set('sidebarStatus', '1')
    } else {
      Cookies.set('sidebarStatus', '0')
    }
  },
  CLOSE_SIDEBAR: (state:any, withoutAnimation:any) => {
    Cookies.set('sidebarStatus', '0')
    state.sidebar.opened = false
    state.sidebar.withoutAnimation = withoutAnimation
  },
  TOGGLE_DEVICE: (state:any, device:any) => {
    state.device = device
  },
  SET_SIZE: (state:any, size:any) => {
    state.size = size
    Cookies.set('size', size)
  },
  SET_SIDEBAR_HIDE: (state:any, status:any) => {
    state.sidebar.hide = status
  }
}

const actions = {
  toggleSideBar({ commit }:any) {
    commit('TOGGLE_SIDEBAR')
  },
  closeSideBar({ commit }:any, { withoutAnimation }:any) {
    commit('CLOSE_SIDEBAR', withoutAnimation)
  },
  toggleDevice({ commit }:any, device:any) {
    commit('TOGGLE_DEVICE', device)
  },
  setSize({ commit }:any, size:any) {
    commit('SET_SIZE', size)
  },
  toggleSideBarHide({ commit }:any, status:any) {
    commit('SET_SIDEBAR_HIDE', status)
  }
}

export default {
  namespaced: true,
  state,
  mutations,
  actions
}
